//+------------------------------------------------------------------+
//|       Dserg_Morning_v1.0.mq4                                        |
//|         EURUSD_M15 / 2009                      |
//+------------------------------------------------------------------+
#property copyright "Dserg"
#property link      "http://forum.alpari.ru/member56010.html"
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

// 
extern double Lots = 1.0;

//    .    
extern double s0 = 0.0;
//    . 2     
extern double t0 = 1.618;
//           
extern int h1=0;
//  
extern int h2=7;
//      
extern double BoxShift=0.0;
//    
extern double MinBox = 0.0;
//    
extern double MaxBox = 10000.0;
double BoxH,BoxL;
//    ,   
extern bool leaveOpposite=false;
//         
extern bool useConstantLot=false;

// 
extern bool useMartingale=false;
//  
extern double Fact=2.0;
//    
extern int Nmax=4;

static int Nmartin=0;
double initBox = 1332.0;
static double RiskCoeff = 1.0;
static double MartinCoeff = 1.0;
static datetime LT=0;
int MagicNumber=7461240;        

int init()
{
   LT=Time[0];
   
   Nmartin=0;
   RiskCoeff=1.0;
   MartinCoeff=1.0;
   initBox *=Point;
   
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| OpenBuyStopOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenBuyStopOrder()
{
   int err,ticket;
   double myStopLoss = 0, myTakeProfit = 0;
   myStopLoss = 0;
   myTakeProfit = 0;
   
   RefreshRates();
   
   //    
   myStopLoss = NormalizeDouble(BoxL+s0*(BoxH-BoxL),Digits);
   myTakeProfit = NormalizeDouble(BoxH+(BoxH-BoxL)*(t0-1.0),Digits);
   
   //  
   double P0 = NormalizeDouble(BoxH,Digits);  
   
   ticket=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(MartinCoeff*RiskCoeff*Lots,2),P0,30,myStopLoss,myTakeProfit,"forward",MagicNumber,0,Green); 
   if(ticket<=0)
   {
      err = GetLastError();
      Print("Error opening BUYSTOP order [" + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}


//+------------------------------------------------------------------+
//| OpenSellStopOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenSellStopOrder()
{
   int err,ticket;
   double myStopLoss = 0, myTakeProfit = 0;
   myStopLoss = 0;
   myTakeProfit = 0;
   
   RefreshRates();
   
   //    
   myStopLoss = NormalizeDouble(BoxH-s0*(BoxH-BoxL),Digits);
   myTakeProfit = NormalizeDouble(BoxL-(BoxH-BoxL)*(t0-1.0),Digits);
   
   //  
   double P0 = NormalizeDouble(BoxL,Digits);  
   
   ticket=OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(MartinCoeff*RiskCoeff*Lots,2),P0,30,myStopLoss,myTakeProfit,"forward",MagicNumber,0,Red); 
   if(ticket<=0)
   {
      err = GetLastError();
      Print("Error opening SELLSTOP order [" + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   if (Time[0]==LT) return(0);
   LT = Time[0];

   if (Hour()<h2 && Hour()>h1) return(0);

   int Nb=openPositionsDet(OP_BUYSTOP,"forward");
   int Ns=openPositionsDet(OP_SELLSTOP,"forward");
   int Nb0=openPositionsDet(OP_BUY,"forward");
   int Ns0=openPositionsDet(OP_SELL,"forward");

   if (Hour()==h1 ) {
         
      CloseBuyStopOrder();
      CloseSellStopOrder();
   }   

   
   if (Hour()==h2 && Nb==0 && Ns==0 && Nb0==0 && Ns0==0) {

      BoxH = iCustom(NULL,PERIOD_M15,"!LinRegrBuf",true,4*(h2-h1),2,0);
      BoxL = iCustom(NULL,PERIOD_M15,"!LinRegrBuf",true,4*(h2-h1),1,0);
      
      double shift = BoxShift*(BoxH-BoxL);
      BoxH = BoxH+shift;
      BoxL = BoxL-shift;
      
      RefreshRates();
      //  .  
      double MinB = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
      Comment(DoubleToStr(MinB/Point,5));
      
      if (Ask>=BoxH-MinB) BoxH=Ask+MinB;
      if (Bid<=BoxL+MinB) BoxL=Bid-MinB;
      
      //   
      if (BoxH-BoxL>MinBox*Point && BoxH-BoxL<MaxBox*Point) {
      
         if (useConstantLot) {
            RiskCoeff = 1.0;
         } else {
            RiskCoeff = initBox/(BoxH-BoxL);
         }
         
         // :
         if(useMartingale){
            if (isLossLastPos("", -1, MagicNumber) && Nmartin<Nmax) {
               MartinCoeff *= Fact;
               Nmartin++;
            } else {
               MartinCoeff = 1.0;
               Nmartin = 0;
            }
         } else {
            MartinCoeff = 1.0;
         }   
         
         OpenBuyStopOrder();
         OpenSellStopOrder();
      }
   }   
   
   if (Nb==1 && Ns==0 && !leaveOpposite) {
      CloseBuyStopOrder();
   }   

   if (Nb==0 && Ns==1 && !leaveOpposite) {
      CloseSellStopOrder();
   }   
     

//----
   return(0);
}
//+------------------------------------------------------------------+

int openPositionsDet(int ORDER, string COMMENT)
{  int op =0;
     for(int i=OrdersTotal()-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() )
         {  
          if ( (OrderType() == ORDER)&&(OrderComment() == COMMENT) ) op++; 
         }
      } 
   return(op);
}
int CloseBuyStopOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_BUYSTOP) { 
            OrderDelete(OrderTicket(),Green);
          }
        }
    } 
    return(0);
}

int CloseSellStopOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_SELLSTOP) { 
            OrderDelete(OrderTicket(),Red);
          }
        }
    } 
    return(0);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :     .                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
bool isLossLastPos(string sy="", int op=-1, int mn=-1) {
  datetime t;
  int      i, j=-1, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (t<OrderCloseTime()) {
                t=OrderCloseTime();
                j=i;
              }
            }
          }
        }
      }
    }
  }
  if (OrderSelect(j, SELECT_BY_POS, MODE_HISTORY)) {
    if (OrderProfit()<0) return(True);
  }
  return(False);
}